Subject: Re: bug#10349: tail: fix --follow on FhGFS remote file systems

From: Sven Breuner <[email-masked]>
Date: Thu, 22 Dec 2011 15:31:58 +0100

Hi Jim,

Jim Meyering wrote on 12/22/2011 11:01 AM:
> Sven Breuner wrote:
>> can you please add the FhGFS remote file system magic "0x19830326" to
>> the inotify blacklist of the src/tail.c:fremote function.
>
> I've attached the expected patch below.

thanks for the patch!
(I had problems finding out how the mechanism works, because I was 
searching for something like a "#define ...MAGIC <number>", which is why 
I didn't submit a patch in the first place. Now I see how it works.)

>> Currently, the inotify mechanism is assumed to be working for all
>> unknown file systems, which probably causes trouble for a lot of the
>> different network file systems out there.
>
> We have a mechanism in place already to ensure that all file system
> types listed in /usr/include/linux/magic.h are known to stat -f.
> I see that FhGFS is not listed there.  If it had been listed a few
> months ago, coreutils-8.14 would now support it.
>
> In your situation (a new remote FS for which GNU tail does not
> yet know its status as a remote FS), there are two ways to work
> around the problem (that inotify failing makes tail -f fail):
>
>    - use the deliberately undocumented tail option, ---disable-inotify
>    - add an argument of "-", telling tail -f to read stdin, which
>        never works with inotify, so tail reverts to polling here, too.

Indeed, we are recommending an alias tail='tail ---disable-inotify' as a 
temporary solution to our users.

>  From 896529709230021ba3d2b0000b28a6c4af13970a Mon Sep 17 00:00:00 2001
> From: Jim Meyering<[email-masked]>
> Date: Thu, 22 Dec 2011 09:26:31 +0100
> Subject: [PATCH] tail,stat: add support for FhGFS
> [...]

Thanks and best regards,
Sven